/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_STUB_DEFAULT_HPP_
#define V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_STUB_DEFAULT_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesStubDefault.hpp>

#include <CommonAPI/Export.hpp>

#include <v1/commonapi/telux/cv2x/Cv2xRadioManagerStub.hpp>
#include <cassert>
#include <sstream>

# if defined(_MSC_VER)
#  if _MSC_VER >= 1300
/*
 * Diamond inheritance is used for the CommonAPI::Proxy base class.
 * The Microsoft compiler put warning (C4250) using a desired c++ feature: "Delegating to a sister class"
 * A powerful technique that arises from using virtual inheritance is to delegate a method from a class in another class
 * by using a common abstract base class. This is also called cross delegation.
 */
#    pragma warning( disable : 4250 )
#  endif
# endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

/**
 * Provides a default implementation for Cv2xRadioManagerStubRemoteEvent and
 * Cv2xRadioManagerStub. Method callbacks have an empty implementation,
 * remote set calls on attributes will always change the value of the attribute
 * to the one received.
 *
 * Override this stub if you only want to provide a subset of the functionality
 * that would be defined for this service, and/or if you do not need any non-default
 * behaviour.
 */
class COMMONAPI_EXPORT_CLASS_EXPLICIT Cv2xRadioManagerStubDefault
    : public virtual Cv2xRadioManagerStub,
      public virtual ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStubDefault {
public:
    COMMONAPI_EXPORT Cv2xRadioManagerStubDefault()
        : remoteEventHandler_(this),
          interfaceVersion_(Cv2xRadioManager::getInterfaceVersion()) {
    }

    COMMONAPI_EXPORT const CommonAPI::Version& getInterfaceVersion(std::shared_ptr<CommonAPI::ClientId> _client) {
        (void)_client;
        return interfaceVersion_;
    }

    COMMONAPI_EXPORT Cv2xRadioManagerStubRemoteEvent* initStubAdapter(const std::shared_ptr< Cv2xRadioManagerStubAdapter> &_adapter) {
        Cv2xRadioTypesStubDefault::initStubAdapter(_adapter);
        CommonAPI::Stub<Cv2xRadioManagerStubAdapter, Cv2xRadioManagerStubRemoteEvent>::stubAdapter_ = _adapter;
        return &remoteEventHandler_;
    }

    COMMONAPI_EXPORT virtual void GetServiceStatus(const std::shared_ptr<CommonAPI::ClientId> _client, GetServiceStatusReply_t _reply) {
        (void)_client;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        ::v1::commonapi::telux::common::CommonDefines::ServiceStatus status = ::v1::commonapi::telux::common::CommonDefines::ServiceStatus::SERVICE_UNAVAILABLE;
        if (!status.validate()) {
            return;
        }
        _reply(error, status);
    }
    COMMONAPI_EXPORT virtual void fireCurrentCv2xStatusEvent(const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status) {
        Cv2xRadioManagerStub::fireCurrentCv2xStatusEvent(_status);
    }
    COMMONAPI_EXPORT virtual void startCv2x(const std::shared_ptr<CommonAPI::ClientId> _client, startCv2xReply_t _reply) {
        (void)_client;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        ::v1::commonapi::telux::common::CommonDefines::Status status = ::v1::commonapi::telux::common::CommonDefines::Status::SUCCESS;
        if (!status.validate()) {
            return;
        }
        _reply(error, status);
    }
    COMMONAPI_EXPORT virtual void stopCv2x(const std::shared_ptr<CommonAPI::ClientId> _client, stopCv2xReply_t _reply) {
        (void)_client;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        ::v1::commonapi::telux::common::CommonDefines::Status status = ::v1::commonapi::telux::common::CommonDefines::Status::SUCCESS;
        if (!status.validate()) {
            return;
        }
        _reply(error, status);
    }
    COMMONAPI_EXPORT virtual void requestCv2xStatus(const std::shared_ptr<CommonAPI::ClientId> _client, requestCv2xStatusReply_t _reply) {
        (void)_client;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus status = {};
        _reply(error, status);
    }
    COMMONAPI_EXPORT virtual void requestCv2xStatusEx(const std::shared_ptr<CommonAPI::ClientId> _client, requestCv2xStatusExReply_t _reply) {
        (void)_client;
        ::v1::commonapi::telux::common::CommonDefines::ErrorCode error;
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx statusEx = {};
        _reply(error, statusEx);
    }


protected:
    class COMMONAPI_EXPORT_CLASS_EXPLICIT RemoteEventHandler: public virtual Cv2xRadioManagerStubRemoteEvent, public virtual Cv2xRadioTypesStubDefault::RemoteEventHandler {
    public:
        COMMONAPI_EXPORT RemoteEventHandler(Cv2xRadioManagerStubDefault *_defaultStub)
            : ::v1::commonapi::telux::common::CommonDefinesStubDefault::RemoteEventHandler(_defaultStub), ::v1::commonapi::telux::cv2x::Cv2xRadioTypesStubDefault::RemoteEventHandler(_defaultStub),
              defaultStub_(_defaultStub) {
        }


    private:
        Cv2xRadioManagerStubDefault *defaultStub_;
    };
protected:
    Cv2xRadioManagerStubDefault::RemoteEventHandler remoteEventHandler_;

private:


    CommonAPI::Version interfaceVersion_;
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_STUB_DEFAULT
